usedcarswebsite/calc/urls.py
from django.conf.urls import url

from . import views

urlpatterns = [
    url(r'^calc/$', views.calc),
    url(r'^calc2/(?P<op>add|sub|mul|div)/$', views.calc_path)
]

usedcarswebsite/cars/urls.py
from django.conf.urls import url

from cars import views

urlpatterns = [
    url(r'^$', views.CarListView.as_view(), name='car_list'),
    url(r'^(?P<car_id>[\w]+)/$', views.CarDetailsView.as_view(), name='car_details'),
    url(r'^(?P<car_id>[\w]+)/edit/$', views.CarEditView.as_view(), name='car_edit'),
    url(r'^(?P<car_id>[\w]+)/delete/$', views.CarDeleteView.as_view(), name='car_delete'),
]

usedcarswebsite/usedcarswebsite/urls.py
from django.conf.urls import url, include
from django.contrib import admin

import cars.urls
import restsimple.urls
import views

urlpatterns = [
    url(r'^$', views.index, name='app_index'),
    url(r'^cars/', include(cars.urls)),
    url(r'^rest/', include(restsimple.urls)),
    url(r'^admin/', admin.site.urls),
    url('^', include('django.contrib.auth.urls')),

]

usedcarswebsite/cars/models.py
from __future__ import unicode_literals

from django.db import models
from django.utils.translation import ugettext_lazy as _


class Car(models.Model):

    ENGINE_BENZIN = 'b'
    ENGINE_DIESEL = 'd'

    ENGINE_CHOICES = [
        (ENGINE_BENZIN, _('Benzin')),
        (ENGINE_DIESEL, _('Diesel')),
    ]

    title = models.CharField(max_length=140)
    link = models.URLField(verbose_name="Advertisement Link")
    company = models.CharField(max_length=140)
    year = models.IntegerField()
    engine_type = models.CharField(max_length=20, choices=ENGINE_CHOICES)

    def __str__(self):
        return self.title

    class Meta:
        ordering = ('title', )

usedcarswebsite/cars/forms.py
from django import forms

from cars import models


class CarEditForm(forms.Form):
    # id = forms.IntegerField(widget=forms.HiddenInput())
    title = forms.CharField(label='Title', max_length=255)
    link = forms.URLField(label='External link', max_length=255)
    company = forms.CharField(label='Company', max_length=255)
    year = forms.IntegerField(label='Year')
    engine_type = forms.ChoiceField(
        label="Engine Type", choices=models.Car.ENGINE_CHOICES)


class CarModelForm(forms.ModelForm):
    class Meta:
        model = models.Car
        fields = ['title', 'link', 'company', 'year', 'engine_type']
        

usedcarswebsite/cars/views.py
from django.core.urlresolvers import reverse
from django.core.paginator import EmptyPage, PageNotAnInteger, Paginator
from django.http import HttpResponseRedirect
from django.shortcuts import render, get_object_or_404
from django.views.generic import View
from django.contrib import messages
from django.contrib.auth.mixins import LoginRequiredMixin
from cars.models import Car
from cars.forms import CarEditForm, CarModelForm


class CarListView(LoginRequiredMixin, View):
    """
    View for displaying list of cars.
    """

    def get(self, request, *args, **kwargs):
        context = {}
        cars = Car.objects.all()
        query = request.GET.get('q')
        if query:
            context['query'] = query
            cars = cars.filter(title__contains=query)
        paginator = Paginator(cars, 10)
        page = request.GET.get('page')
        try:
            cars = paginator.page(page)
        except PageNotAnInteger:
            cars = paginator.page(1)
        except EmptyPage:
            cars = paginator.page(paginator.num_pages)

        context['cars'] = cars
        context['new_car_form'] = CarModelForm()

        return render(request, 'cars/car_list.html', context=context)

    def post(self, request, *args, **kwargs):

        car_form = CarModelForm(request.POST)

        if car_form.is_valid():
            car = car_form.save()
            messages.success(request, 'New Car created!')
            return HttpResponseRedirect(reverse('car_list'))
        return render(request, 'cars/car_edit.html', context={
            'new_car_form': car_form
        })


class CarDetailsView(View):
    """
    View for displaying car details.
    """

    def get(self, request, *args, **kwargs):
        return render(
            request, 
            'cars/car_details.html', 
            context={'car': get_object_or_404(Car, id=kwargs['car_id'])})


class CarEditView(View):
    """
    View for editing car details.
    """

    def get(self, request, *args, **kwargs):
        context = {}
        try:
            car = Car.objects.get(id=kwargs['car_id'])
            context['car'] = car
        except Car.DoesNotExist:
            messages.error(request,
                           'No car with id: {}'.format(kwargs['car_id']))

        context['car_form'] = CarModelForm(instance=car)
        return render(request, 'cars/car_edit.html', context=context)

    def post(self, request, *args, **kwargs):

        car = Car.objects.get(id=kwargs['car_id'])
        car_form = CarModelForm(request.POST, instance=car)

        if car_form.is_valid():
            car = car_form.save()
            messages.success(request, 'Object saved!')
            return HttpResponseRedirect(reverse('car_details', kwargs={
                'car_id': car.id
            }))
        return render(request, 'cars/car_edit.html', context={
            'car': car,
            'car_form': car_form
        })


class CarDeleteView(View):
    """
    View for editing car details.
    """

    def get(self, request, *args, **kwargs):
        context = {}
        try:
            car = Car.objects.get(id=kwargs['car_id'])
            context['car'] = car
        except Car.DoesNotExist:
            messages.error(request,
                           'No car with id: {}'.format(kwargs['car_id']))
        return render(request, 'cars/car_delete.html', context=context)

    def post(self, request, *args, **kwargs):
        car = Car.objects.get(id=kwargs['car_id'])
        car.delete()
        messages.success(request, 'Car deleted!')
        return HttpResponseRedirect(reverse('car_list'))

usedcarswebsite/cars/templates/cars/base.html
{# Load the tag library #} 
{% load staticfiles i18n static %}

<!DOCTYPE html>
<html lang="en">
    <head class="no-js" lang="en" dir="ltr">
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>cars...</title>
        <meta name="description" content="">
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Ubuntu">
        <link rel="stylesheet" href="{% static 'cars/css/foundation.min.css' %}">
        <link rel="stylesheet" href="{% static 'cars/css/toastr.css' %}">
        <link rel="stylesheet" href="{% static 'cars/css/app.css' %}">
    </head>

    <body>
        <header>
            <div class="top-bar">
                <div class="top-bar-title">
                    <span data-responsive-toggle="main-menu" data-hide-for="medium">
                        <button class="menu-icon" type="button" data-toggle></button>
                    </span>
                    <strong><a href="{%url 'app_index'%}">Used Cars</a></strong>
                </div>
                <div id="main-menu">
                  <div class="top-bar-left">
                    <ul class="menu">
                      <li><a href="{% url 'car_list' %}">Cars</a></li>
                    </ul>
                  </div>
                  <div class="top-bar-right">
                    <ul class="menu">
                      
                      {% if user.is_authenticated %}
                        <li><a href="#">Hello {{ user.username }}!</a></li>
                        <li><a href="{% url 'logout' %}">Sign Out</a></li>
                      {% else %}
                        <li><a href="{% url 'login' %}">Sign In</a></li>
                        
                      {% endif%}
                    </ul>
                  </div>
                </div>
            </div>
        </header>
        <main>
        {% block main %}
        {% endblock %}
        </main>
        <footer>
        </footer>
        <script src="{% static 'cars/js/vendor/jquery.js' %}"></script>
        <script src="{% static 'cars/js/vendor/foundation.min.js' %}"></script>
        <script src="{% static 'cars/js/vendor/toastr.min.js' %}"></script>
        <script src="{% static 'cars/js/app.js' %}"></script>

        {% block script %}
        {% endblock %}
    </body>

</html>

usedcarswebsite/cars/templates/cars/car_delete.html
{% extends "cars/base.html" %}

{% block main %}
	{% for message in messages %}
	<div class="row">
		<div class="small-12 column">
			<div class="callout alert" data-closable>
				<p> {{message}} </p>
				<button class="close-button" aria-label="Dismiss alert" type="button" data-close>
    				<span aria-hidden="true">&times;</span>
  				</button>
			</div>
		</div>
	</div>
	{% endfor %}
	{% if car %}
	<div class="row">
		<div class="small-12 column">
			<h3>Are you sure?</h3>
			<p>Are you sure you want to delete the car "{{car.title}}"</p>
			<div>
				<form action="{% url 'car_delete' car_id=car.id %}" method="post">
    				{% csrf_token %}
    				<input class="button alert" type="submit" value="Delete">
    			</form>
			</div>
		</div>
	</div>
	{% endif %}	
{% endblock %}

usedcarswebsite/cars/templates/cars/car_details.html
{% extends "cars/base.html" %}

{% block main %}
	{% for message in messages %}
	<div class="row">
		<div class="small-12 column">
			<div class="callout {{ message.tags }}" data-closable>
				<p> {{message}} </p>
				<button class="close-button" aria-label="Dismiss alert" type="button" data-close>
    				<span aria-hidden="true">&times;</span>
  				</button>
			</div>
		</div>
	</div>
	{% endfor %}
	
	{% if car %}
	<div class="row">
		<div class="small-12 column">
			<h3>{{car.title}}</h3>
		</div>
	</div>
	<div class="row">
		<div class="small-3 column text-right">
			<label>Company:</label>
		</div>
		<div class="small-9 column">
			{{car.company}}
		</div>
	</div>
	<div class="row">
		<div class="small-3 column text-right">
			<label>Year:</label>
		</div>
		<div class="small-9 column">
			{{car.year}}
		</div>
	</div>	
	<div class="row">
		<div class="small-3 column text-right">
			<label>Engine type:</label>
		</div>
		<div class="small-9 column">
			{{car.get_engine_type_display}}
		</div>
	</div>	
	<div class="row">
		<div class="small-3 column text-right">
			
		</div>
		<div class="small-9 column">
			<a class="button" href="{{car.link}}" target="_blank">Details</a>
		</div>
	</div>
	<div class="row">
		<div class="small-12 column">
			<div class="button-group">
				<a class="button primary" href="{% url 'car_edit' car_id=car.id%}">Edit</a>
				<a class="button alert" href="{% url 'car_delete' car_id=car.id%}">Delete</a>
			</div>
		</div>
	</div>
	{% endif %}	
	
{% endblock %}

usedcarswebsite/cars/templates/cars/car_edit.html
{% extends "cars/base.html" %}

{% block main %}
	{% for message in messages %}
	<div class="row">
		<div class="small-12 column">
			<div class="callout {{message.tag}}" data-closable>
				<p> {{message}} </p>
				<button class="close-button" aria-label="Dismiss alert" type="button" data-close>
    				<span aria-hidden="true">&times;</span>
  				</button>
			</div>
		</div>
	</div>
	{% endfor %}
	{% if car %}
	<div class="row">
		<div class="small-12 column">
			<h3>Edit car: {{ car.title}}</h3>
			<form novalidate action="{% url 'car_edit' car_id=car.id %}" method="post">
    			{% csrf_token %}
				{{ car_form }}
				<div class="button-group">
					<input class="button primary" type="submit" value="Save">
					<a class="button secondary" href="{% url 'car_details' car_id=car.id %}">Cancel</a>
				</div>
			</form>
		</div>
	</div>
	{% endif %}	
{% endblock %}

usedcarswebsite/cars/templates/cars/car_list.html
{% extends "cars/base.html" %}

{% block main %}
	<div class="row">
		<div class="small-12 column">
			<h3>Cars</h3>
		</div>
	</div>
	<div class="row">
		<div class="small-12 column">
			<ul class="accordion" data-accordion data-allow-all-closed="true">
  				<li class="accordion-item" data-accordion-item>
    				<a href="#" class="accordion-title">Add new car</a>
    				<div id="new_car_form" class="accordion-content" data-tab-content>
						<form id="form_new_car" novalidate action="{% url 'car_list' %}" method="post">
							{% csrf_token %}
							{{ new_car_form }}
							<div class="button-group">
								<input class="button primary" type="submit" value="Save">
								<a id="btn_cancel" class="button secondary">Cancel</a>
							</div>
    					</form>
					</div>
				</li>
				<li class="accordion-item" data-accordion-item>
    				<a href="#" class="accordion-title">Filter</a>
    				<div id="filter_form" class="accordion-content" data-tab-content>
						<form id="form_filter" novalidate action="" method="get">
							<label>Search cars:
								<input name="q" type="text" value={{query}}>
							</label>
							<div class="button-group">
								<input class="button primary" type="submit"  value="Search">
								<a href="{% url 'car_list' %}" class="button secondary">Clear</a>
							</div>
    					</form>
					</div>
				</li>
			</ul>
	</div>

	<div class="row">
		<div class="small-12 column">
			<ul class="pagination text-center" role="navigation" aria-label="Pagination">
				{% if cars.has_previous %}
					<li class="pagination-previous"><a href="?page={{ cars.previous_page_number }}&q={{query}}">Previous</a></li>
				{% else %}
					<li class="pagination-previous disabled">Previous</li>
				{% endif %}
				{% if cars.has_next %}
					<li class="pagination-next"><a href="?page={{ cars.next_page_number }}&q={{query}}">Next</a></li>
				{% else %}
					<li class="pagination-next disabled">Next</li>
				{% endif %}
			</ul>
		</div>
	</div>
	<div class="row">
		<div class="small-12 column">
			<ul>
				{% for car in cars %}
					<li>
						<a href="{% url 'car_details' car_id=car.id %}">{{ car.title }}</a>
					</li>
				{% endfor %}
			</ul>
		</div>
	</div>	


{% endblock %}

{% block script %}
<script>
	$('#btn_cancel').click(function (){
		$('.accordion').foundation('toggle', $('#new_car_form'));
		
		$('#form_new_car :input[type=text]').each(function(){
			$(this).val('');
		});
		$('#form_new_car :input[type=url]').each(function(){
			$(this).val('');
		});
		$('#form_new_car :input[type=number]').each(function(){
			$(this).val('');
		});
	});
</script>
{% endblock%}

usedcarswebsite/cars/templates/cars/index.html
{% extends "cars/base.html" %}

{% block main %}
		<h1>Welcome to used cars website!</h1>
{% endblock %}